extends RigidBody2D
class_name Asteroid

var asteroid_type: AsteroidResource
var start_force: Vector2 = Vector2.ZERO
var start_spin: float = 0.0
var health: int = 0
@onready var ttl: Timer = $TTL
@onready var sprite_2d: Sprite2D = $Sprite2D
@onready var animation_player: AnimationPlayer = $AnimationPlayer


func _ready() -> void:
	sprite_2d.texture = asteroid_type.visual
	var shape: Shape2D = $CollisionShape2D.shape
	shape.radius = (asteroid_type.visual.get_width() / 2.0) - 2
	linear_velocity = start_force
	angular_velocity = deg_to_rad(start_spin)
	health = 1 if asteroid_type.health == 0 else asteroid_type.health


func take_damage() -> void:
	animation_player.play("flash")
	await animation_player.animation_finished
	health -= 1
	if health <= 0:
		queue_free()
		Relay.gain_point.emit()


func _on_screen_entered() -> void:
	ttl.stop()


func _on_screen_exited() -> void:
	ttl.start()
