extends CanvasLayer

@onready var point_counter: Label = %PointCounter
@onready var high_counter: Label = %HighCounter
@onready var game_over: VBoxContainer = %GameOver
@onready var title_screen: VBoxContainer = %TitleScreen


func _ready() -> void:
	Relay.current_score.connect(on_score_updated)
	Relay.game_over.connect(on_game_over)


func _unhandled_input(event: InputEvent) -> void:
	if not game_over.visible and not title_screen.visible: return
	if event.is_action_pressed("clear_high_score"):
		Relay.reset_high_score.emit()


func on_score_updated(new_score: int) -> void:
	point_counter.text = str(new_score)


func on_game_over() -> void:
	game_over.visible = true


func _on_start_pressed() -> void:
	Relay.game_start.emit()
	title_screen.hide()
	get_tree().paused = false


func _on_restart_pressed() -> void:
	Relay.game_restart.emit()
	game_over.hide()
	get_tree().paused = false
